//
//IMPLEMENTA IL COORDINATORE DI PRIMO INSERIMENTO
import java.net.*;
import java.io.*;

public class CoordinatorFirst extends Thread
	{
	private ServerConfig HostConfig;
	private Socket Succ;
	private Socket Prec;
	
	CoordinatorFirst(Socket s1, Socket s2, ServerConfig s)	
		{
		super("Coordinatore-First");
		HostConfig=s;
		Succ=s1;
		Prec=s2;
		}
	
	public void run()
		{
		try {
			Log.netLogging("--------INSERT NEW SERVER--------");
			Log.netLogging(getName()+" start");
			//ridefinizione delle connessioni
		/**/	ObjectOutputStream SuccWR=new ObjectOutputStream(Succ.getOutputStream());
		/**/	SuccWR.flush();
		/**/	ObjectInputStream PrecRD=new ObjectInputStream(Prec.getInputStream());	
		/**/	ObjectOutputStream PrecWR=new ObjectOutputStream(Prec.getOutputStream());
		/**/	PrecWR.flush();
		/**/	ObjectInputStream SuccRD=new ObjectInputStream(Succ.getInputStream());
			byte typemsg;
			//invio messaggio di YOUR_PRIORITY_IS
			MsgYourPriorityIs smsg3=new MsgYourPriorityIs(InetAddress.getLocalHost().getHostAddress(), 1);
			//settaggio nuova priorit del server (azione sincronizzata)
			HostConfig.setPriorityHost(0);
			Log.netLogging(getName()+": set host priority 0");
			synchronized (SuccWR)
					{
					SuccWR.writeByte(Message.codeMsg("YPI"));
					SuccWR.writeObject(smsg3);
					SuccWR.flush();
					}
			Log.netLogging(getName()+": send YOUR_PRIORITY_IS");
			Log.netLogging("%% "+Succ.toString());
			//invio database
			synchronized (SuccWR)
				{
				SuccWR.writeByte(Message.codeMsg("db"));
				SuccWR.writeObject(HostConfig.getDatabase());
				SuccWR.flush();
				}
			Log.netLogging(getName()+": send database");
			Log.netLogging("%% "+Succ.toString());
			//attesa YOUR_PRIORITY_IS
			typemsg=PrecRD.readByte();
			if (Message.decodeMsg(typemsg).equals("YPI"))
				{
				MsgYourPriorityIs rmsg=(MsgYourPriorityIs) PrecRD.readObject();
				Log.netLogging(getName()+": receive a YOUR_PRIORITY_IS");
				Log.netLogging("%% "+Prec.toString());
				if (rmsg.getIPaddrCoordinator().equals(InetAddress.getLocalHost().getHostAddress()))
					{//messaggio generato da questo server
					MsgResurrection smsg4=new MsgResurrection(InetAddress.getLocalHost().getHostAddress());
					synchronized(SuccWR)
						{
						SuccWR.writeByte(Message.codeMsg("RSU"));
						SuccWR.writeObject(smsg4);
						SuccWR.flush();
						}
					Log.netLogging(getName()+": send RESURRECTION");
					Log.netLogging("%% "+Succ.toString());
					}
				typemsg=PrecRD.readByte();
				if (Message.decodeMsg(typemsg).equals("RSU"))
					{
					MsgResurrection rmsg2=(MsgResurrection) PrecRD.readObject();
					if (rmsg2.getIPaddrGenerator().equals(InetAddress.getLocalHost().getHostAddress()))
						; //messaggio ritornato e distrutto
					else
						Log.netLogging("($$$) [ERROR] "+getName()+": receive message, two RESURRECTION in ring");
						//Object ignored=PrecRD.readObject();	
					}
				else
					Log.netLogging("($$$) [ERROR] "+getName()+": receive message, not RESURRECTION");
					//Object ignored=PrecRD.readObject();	
				}
			else
				Log.netLogging("($$$) [ERROR] "+getName()+": receive message, not YOUR_PRIORITY_IS");
				//Object ignored=PrecRD.readObject();	
				//controllo della provenenza!!!!!!!
			
		/**/	HostConfig.setSuccSock(Succ);
		/**/	HostConfig.setPrecSock(Prec);
		/**/	HostConfig.setSuccWR(SuccWR);
		/**/	HostConfig.setPrecRD(PrecRD);
		/**/	HostConfig.setSuccRD(SuccRD);
		/**/	HostConfig.setPrecWR(PrecWR);
		
		//	SuccWR.close();
		//	SuccRD.close();
		//	PrecRD.close();
		//	PrecWR.close();
			//ridefinizione connessioni dei demoni
			HostConfig.getDeamonBook().redefineSuccHost();
			HostConfig.getDeamonBook().redefinePrecHost();
			HostConfig.getDeamonNetwork().redefineSuccHost();
			HostConfig.getDeamonNetwork().redefinePrecHost();
			HostConfig.getDeamonCrash().redefineSuccHost();
			HostConfig.getDeamonCrash().redefinePrecHost();
			Log.netLogging(getName()+": redefined all connection");
			Log.netLogging("%% successor is "+Succ.toString());
			Log.netLogging("%% predecessor is "+Prec.toString());
			//partenza di tutti i demoni del sistema fino ad ora non lanciati in quanto server unico
			Log.netLogging(getName()+": Daemon Book, Network, Crash & Crash-Detect started....");
			HostConfig.getDeamonCrash().start();
			HostConfig.getDeamonBook().start();
			HostConfig.getDeamonNetwork().start();
			HostConfig.getDeamonCrashDetect().start();
			Log.netLogging(getName()+" stop");
			yield();
			Log.netLogging("--------END INSERT NEW SERVER--------");
			}
		catch (IOException e)
			{
			Log.netLogging("#####################################################");
			Log.netLogging("#### "+getName()+": SYSTEM HALTED - Ring Crash #####");
			Log.netLogging("#####################################################");
			HostConfig.Halted();
			stop();
			}
		catch (Exception e) {Log.netLogging("($$$) [EXCEPTION] "+getName()+" "+e);}
		}
	}