//
//IMPLEMENTA IL THREAD DI COORDINAMENTO DI UN INSERIMENTO
import java.net.*;
import java.io.*;

public class CoordinatorNext extends Thread
	{
	private Socket SockIns;
	private ServerConfig HostConfig;
	private boolean winnerinsert;
	private Holder dh;
	
	CoordinatorNext(Socket s, ServerConfig c)
		{
		super("Coordinator-Next");
		SockIns=s;
		HostConfig=c;
		dh=new Holder(this, HostConfig);
		}
	public Holder getHolder()			{return dh;}
	public synchronized void setWinnerInsert(boolean b)	{winnerinsert=b;}
	
	public void run()
		{
		try {
			Log.netLogging(getName()+": wait result of coordinator for insert");
			Log.netLogging(getName()+": ....");
			dh.start();
			try {dh.join();}
			catch (InterruptedException e) {/*ignored*/}
			if (winnerinsert)	
				{
//vincitore della contesa per l'inserimento
				Log.netLogging(getName()+": winner insert");
				Log.netLogging("--------INSERT NEW SERVER--------");
				//preleva lo stream di scrittura sul successore e di lettura dal predecessore
				ObjectInputStream PrecRD=HostConfig.getPrecRD();
				ObjectOutputStream SuccWR=HostConfig.getSuccWR();
				Log.netLogging(getName()+": start");
				//invio ANCHOR_SERVER
				MsgAnchorServer smsg0=new MsgAnchorServer(SockIns.getInetAddress().getHostAddress());
				synchronized(SuccWR)
					{
					SuccWR.writeByte(Message.codeMsg("AS"));
					SuccWR.writeObject(smsg0);
					SuccWR.flush();
					}
				Log.netLogging(getName()+": send ANCHOR_SERVER");
				Log.netLogging("%%  "+HostConfig.getSuccSock().toString());
				//ottenimento stream socket si connessione con il nuovo successore				
				SuccWR=new ObjectOutputStream(SockIns.getOutputStream());
				SuccWR.flush();
				ObjectInputStream SuccRD=new ObjectInputStream(SockIns.getInputStream());
				//ridefinizione socket successore
				Log.netLogging(getName()+": redefine successor connection");
				Log.netLogging("%%  "+SockIns.toString());
			/**/	HostConfig.getSuccSock().close();
			/**/	HostConfig.setSuccSock(SockIns);
			/**/	HostConfig.setSuccWR(SuccWR);
			/**/	HostConfig.setSuccRD(SuccRD);
				HostConfig.getDeamonBook().redefineSuccHost();
				HostConfig.getDeamonNetwork().redefineSuccHost();
				HostConfig.getDeamonCrash().redefineSuccHost();
																
				//invio YOUR_PRIORITY_IS
				MsgYourPriorityIs smsg3=new MsgYourPriorityIs(InetAddress.getLocalHost().getHostAddress(), 1);
				HostConfig.setPriorityHost(0);
				Log.netLogging(getName()+": set priority host 0");
				synchronized (SuccWR)
				//garantisce l'atomicit della scrittura
					{
					SuccWR.writeByte(Message.codeMsg("YPI"));
					SuccWR.writeObject(smsg3);
					SuccWR.flush();
					}
				Log.netLogging(getName()+": send YOUR_PRIORITY_IS");
				Log.netLogging("%%  "+HostConfig.getSuccSock().toString());
				//invio database
				synchronized (SuccWR)
					{
					SuccWR.writeByte(Message.codeMsg("db"));
					SuccWR.writeObject(HostConfig.getDatabase());
					SuccWR.flush();
					}
				Log.netLogging(getName()+": send DataBase");
				Log.netLogging("%%  "+HostConfig.getSuccSock().toString());
				//attesa del ritorno del YOUR_PRIORITY_IS
				byte typemsg=PrecRD.readByte();
				if (Message.decodeMsg(typemsg).equals("YPI"))
					{
					MsgYourPriorityIs rmsg=(MsgYourPriorityIs) PrecRD.readObject();
					Log.netLogging(getName()+": receive YOUR_PRIORITY_IS");
					Log.netLogging("%%  "+HostConfig.getPrecSock().toString());
					if (rmsg.getIPaddrCoordinator().equals(InetAddress.getLocalHost().getHostAddress()))
						{//messaggio generato da questo server
						//invio RESURRECTION
						MsgResurrection smsg4=new MsgResurrection(InetAddress.getLocalHost().getHostAddress());
						synchronized(SuccWR)
							{
							SuccWR.writeByte(Message.codeMsg("RSU"));
							SuccWR.writeObject(smsg4);
							SuccWR.flush();
							}
						Log.netLogging(getName()+": send RESURRECTION");
						Log.netLogging("%%  "+HostConfig.getSuccSock().toString());
						typemsg=PrecRD.readByte();
						if (Message.decodeMsg(typemsg).equals("RSU"))
							{
							MsgResurrection rmsg2=(MsgResurrection) PrecRD.readObject();
							if (rmsg2.getIPaddrGenerator().equals(InetAddress.getLocalHost().getHostAddress()))
								Log.netLogging("--------END INSERT NEW SERVER--------");
								//messaggio ritornato e distrutto
							else
								Log.netLogging("[ERROR] "+getName()+": receive message, two RESURRECTION in ring");
								//Object ignored=PrecRD.readObject();	
							}
						else
							Log.netLogging("[ERROR] "+getName()+": receive message, not RESURRECTION");
							//Object ignored=PrecRD.readObject();
						}
					else //YPI non generato da questo server
						;//ERRORE altro inserimento in atto
					}
				else //non YPI
					;//ERRORE messaggio non considerato
				}
			else	//contesa persa
				Log.netLogging(getName()+": insert loose");//inserimento perso
			}//end try
		catch (IOException e)
			{
			Log.netLogging("#######################################################");
			Log.netLogging("#### "+getName()+": SYSTEM HALTED - Ring Crash #####");
			Log.netLogging("#######################################################");
			HostConfig.Halted();
			stop();
			}
		catch (Exception e) 	{Log.netLogging("($$$) "+getName()+": "+e);}
		}
	}
	
class Holder extends Thread
	{
	private CoordinatorNext father;
	private ServerConfig hc;
	Holder(CoordinatorNext cn, ServerConfig h)	{super("holder"); father=cn; hc=h;}
	public void run()
		{
		try {
		//preleva lo stream di scrittura sul successore
		ObjectOutputStream SuccWR=hc.getSuccWR();
		//sospensione in attesa della risoluzione per la contesa di inserimento, sar il demone di rete a risvegliarlo
		hc.getDeamonNetwork().RegistryForInsert(father);
		//invio dell'HOLD_SERVICE sulla rete
		MsgHoldService smsg=new MsgHoldService(InetAddress.getLocalHost().getHostAddress(), hc.getPriorityHost());
		synchronized (SuccWR)
		//azione atomica non interferente con quelle, eventuali, del demone di rete
			{
			SuccWR.writeByte(Message.codeMsg("HS"));
			SuccWR.writeObject(smsg);
			SuccWR.flush();
			}
		Log.netLogging(getName()+": send HOLD_SERVICE");
		Log.netLogging("%%  "+hc.getSuccSock().toString());
		suspend();	//aspetta la terminazione
		}
		catch (IOException e)	
			{//eccezione data da pipe interrotta (il successore e' caduto)
			Log.netLogging("?? "+getName()+": Successor Probably Down: Check For Halted System......");
			father.setWinnerInsert(true); 
			stop();
			}
		catch (Exception e) 	{Log.netLogging("($$$) "+getName()+": "+e);}
		}
	}