//13/06/2000
//IMPLEMENTA IL DATABASE CONTENENTE LE INFORMAZIONI SUI VOLI E SUI POSTI PRENOTATI

import java.io.Serializable;

public class Db
implements Serializable
	{
	protected int MAX_NUM_FLY=100;
	//numero massimo di voli nel database
	private int NumFlight;
	//numero di voli significativi
	protected Flight RegistryFly[];
	//insieme dei voli
	
	private final int INCREASED_DUMP=20;
	
	Db()
		{
		NumFlight=0;
		RegistryFly=new Flight[MAX_NUM_FLY];
		}
	Db(int nf)
		{
		MAX_NUM_FLY=nf;
		NumFlight=0;
		RegistryFly=new Flight[MAX_NUM_FLY];
		}
		
	public int getNumFly()
	//RESTITUISCE IL NUMERO DI VOLI SIGNIFICATIVI
		{return NumFlight;}
		
	public Flight getFlight(int pos) throws Exception
		{
		if (pos<NumFlight)
			return RegistryFly[pos];
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position");
		}
		
	public FlightAttrib getFlightAttrib(int pos) throws Exception
	//RESTITUISCE IL VOLO NELLA POSIZIONE INDICATA
		{if (pos<NumFlight)
			return RegistryFly[pos].getFlightAttrib();
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position");
		}
		
	public ClientAttrib getClientAttrib(int pos, int r, int c) throws Exception
	//RESTITUISCE GLI ATTRIBUTI DEL CLIENTE CHE HA PRENOTATO
		{
		if (pos<NumFlight)
			try{ return RegistryFly[pos].getClientAttrib(r,c);}
			catch (Exception e) {throw e;}
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position");
		}
		
	public int posFlight(FlightKey cf)
	//RESTITUISCE LA POSIZIONE DI UN VOLO (-1 se non esiste)
		{
		for (int i=0; i<NumFlight; i++)
			if (cf.getKey()==RegistryFly[i].getFlightAttrib().getFlightKey().getKey())
				return i;
		return -1;
		}
	public synchronized boolean addFlight(FlightAttrib f)
	//AGGIUNGE UN NUOVO VOLO CON CERTI ATTRIBUTI AL DATABASE
	//ritorna false se il database  pieno
		{
		if (NumFlight<MAX_NUM_FLY)
			{
			NumFlight++;
			RegistryFly[NumFlight-1]=new Flight(f);
			return true;
			}
		else
			return false;
		}
	public synchronized boolean addFlight(Flight f)
	//AGGIUNGE UN NUOVO VOLO CON CERTI ATTRIBUTI AL DATABASE
	//ritorna false se il database  pieno
		{
		if (NumFlight<MAX_NUM_FLY)
			{
			NumFlight++;
			RegistryFly[NumFlight-1]=f;
			return true;
			}
		else
			return false;
		}	
	public synchronized void delFlight(int pos) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			{
			RegistryFly[pos]=RegistryFly[NumFlight-1];
			//sposta l'ultimo al posto di quello da cancellare
			RegistryFly[NumFlight]=new Flight();
			NumFlight--;
			//annulla l'ultimo
			}
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly - delFlight: Invalid Flight Position"); 
		}
	public synchronized boolean addBooking(int pos, int r, int n, ClientAttrib c) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			{
			try {return RegistryFly[pos].addBook(c,r,n);}
			catch (Exception e) {throw e;}
			}
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly - addBooking: Invalid Flight Position"); 
		}
	public synchronized void delBooking(int pos, int r, int n) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			{
			try {RegistryFly[pos].delBook(r,n);}
			catch (Exception e) {throw e;}
			}
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position"); 
		}
	public boolean isBooking(int pos, int r, int n) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			return RegistryFly[pos].isBook(r,n);
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position");
		}
	public FlightAttrib[] getFlightList()
		{
		FlightAttrib[] app1=new FlightAttrib[NumFlight];
		int ind=0;
		while (ind<NumFlight)
			{
			app1[ind]=RegistryFly[ind].getFlightAttrib();
			ind++;
			}
		FlightAttrib[] app=new FlightAttrib[ind];
		for (int y=0; y<ind; y++)
			app[y]=app1[y];
		return app;
		}	
	public ClientAttrib[][] getSeatList(int pos) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			return RegistryFly[pos].getBook();
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position"); 
		}
	public int[] getFreeSeatList(int pos) throws Exception
		{
		int index=0;
		if ((pos<NumFlight) & (pos>=0))
			{
			Flight f=RegistryFly[pos];
			int row=f.getNumRow();
			int num=f.getNumNum();
			int[] app1=new int[2*row*num];
			for (int r=0; r<row; r++)
				for (int n=0; n<num; n++)
					{
					try {
						if (!(f.isBook(r,n)))
							{
							index+=2;
							app1[index-2]=r;
							app1[index-1]=n;
							}
						}	
					catch (Exception e ) {throw e;}
					}
			int[] app=new int[index];
			for (int y=0; y<index; y++)
				app[y]=app1[y];
			return app;
			}
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position"); 
		}
	public int[] getClientSeat(int pos, ClientKey ck) throws Exception
		{
		if ((pos<NumFlight) & (pos>=0))
			return RegistryFly[pos].getClientSeat(ck);
		else
			throw new ArrayIndexOutOfBoundsException("RegistryFly: Invalid Flight Position"); 
		}
		
	public FlightAttrib[] getClientFly(ClientKey ck)
		{
		FlightAttrib[] app1=new FlightAttrib[getNumFly()];
		int indfly=0;
		int nf=getNumFly();
		for (int f=0; f<nf; f++)
			{
			int ro=RegistryFly[f].getNumRow();
			int nu=RegistryFly[f].getNumNum();
			for (int r=0; r<ro; r++)
				{
				boolean trovatouno=false;
				for (int n=0; n<nu; n++)
					{
					try {trovatouno=(getClientAttrib(f,r,n).getClientKey().getKey()==ck.getKey());}
					catch (Exception e) {	}
					if (trovatouno)
						{
						app1[indfly]=RegistryFly[f].getFlightAttrib();
						indfly++;
						break;
						}
					}
				if (trovatouno)
					break;
				}
			}
		FlightAttrib[] app=new FlightAttrib[indfly];
		for (int y=0; y<indfly; y++)
			app[y]=app1[y];
		return app;
		}
	
	//uso protetto!!!!!!!!!!!! usate solo da DumpDB()	
	private void setNumFly(int n)
		{ NumFlight=n;}
	private Flight[] getDb()
		{return RegistryFly;}
		
	public synchronized Db DumpDB()
	//ESPANDE IL DATABASE
		{
		Db newDB=new Db(MAX_NUM_FLY+INCREASED_DUMP);
		newDB.setNumFly(this.getNumFly());
		newDB.RegistryFly=this.getDb();
		return newDB;
		}
		
	}