//ult. rev 28/07/2000
//IMPLEMENTA IL DEMONE CHE RICEVE LE RICHIESTE DI 'IS ALIVE?'
import java.net.*;
import java.io.*;

public class DeamonCrashDetect extends Thread
	{
	private ServerConfig HostConfig;
	
	DeamonCrashDetect(ServerConfig s)
		{
		super("DEAMON CRASH DETECT");
		HostConfig=s;
		}
	
	public void run()
		{
		try {	
			//socket d'ascolto per i crash
			Log.netLogging("@@@@@@ "+getName()+" Active!!");
			ServerSocket SockCrash=new ServerSocket(CServer.PORTCD);
			Log.netLogging(getName()+": socket listen at "+CServer.PORTCD);
			while (true)
				{
				Socket OKSock=SockCrash.accept();
				Log.netLogging(getName()+": accept crash-detect");
				Log.netLogging("%% "+OKSock.toString());
				//stream di input della socket di comunicazione predecessore-successore
				ObjectInputStream OKRD=new ObjectInputStream(OKSock.getInputStream());
				byte typemsg=OKRD.readByte();
				if (Message.decodeMsg(typemsg).equals("OD"))
					{
					MsgOriginDetect rmsg=(MsgOriginDetect) OKRD.readObject();
					Log.netLogging(getName()+": receive ORIGIN_DETECT from "+rmsg.getIPaddrOrigin());
					if (!(rmsg.getIPaddrOrigin().equals(InetAddress.getLocalHost().getHostAddress())))
						{
						//originato in un'altro server
						ThreadDetect td=new ThreadDetect(HostConfig, rmsg);
						td.start();
						}
					else	//originato localmente
						//fine protocollo locale di crash-detect
						Log.netLogging(getName()+": Ring OK");
					}
				else
					Log.netLogging("($$$) "+getName()+": receive not ORIGIN DETECT");
				OKRD.close();
				OKSock.close();
				}
			}
		catch (OptionalDataException e) 	{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION] "+getName()+" "+e); stop();}
		catch (ClassNotFoundException e) 	{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION] "+getName()+" "+e); stop();}
		catch (UnknownHostException e)		{Log.netLogging("($$$) [ADDRESS HOST EXCEPTION] "+getName()+" "+e); stop();}
		catch (StreamCorruptedException e) 	{Log.netLogging("($$$) [NEW INPUT STREAM EXCEPTION] "+getName()+" "+e); stop();}
		catch (EOFException e)			{/*ignored*/}
		catch (IOException e) 			{Log.netLogging("($$$) [READ STREAM EXCEPTION] "+getName()+" "+e); stop();}
		}
	}