//24/06/2000
// IMPLEMENTAZIONE DEL DEMONE DI GESTIONE DELLA RETE

import java.net.*;
import java.io.*;

public class DeamonNetwork extends Thread
	{
	private ObjectInputStream PrecRD;	//stream di lettura sul successore
	private ObjectOutputStream SuccWR;	//stream di scrittura sul predecessore
	private ServerConfig HostConfig;	//riferimento alla configurazione del server
	private CoordinatorNext coo;		//eventuale riferimento al thread coordinatore di un inserimento
	
	DeamonNetwork(ServerConfig c)
		{
		super("DEAMON NETWORK");
		HostConfig=c;
		SuccWR=null;
		PrecRD=null;
		}
	//procedure necessarie alla ridefinizione delle connessioni con i vicini
	public synchronized void redefineSuccHost()		{SuccWR=HostConfig.getSuccWR();}
	public synchronized void redefinePrecHost()		{PrecRD=HostConfig.getPrecRD();}
	//procedura di registrazione per l'inserimento		
	public synchronized void RegistryForInsert(CoordinatorNext t)	{coo=t;}
		
	public void run()
		{
		Log.netLogging("@@@@@@ "+getName()+": Active!!");
		while (true)	//ciclo infinito
			{
			try{
			boolean okmsgrcv=false;
			byte typemsg=-1;
			boolean reread=true;
			while (reread) 
				{
				try {
				typemsg=PrecRD.readByte();
				reread=false;
					}
				catch (SocketException e) {;} //ridefinizione socket durante la sospensione}
				}
			if (Message.decodeMsg(typemsg).equals("HS"))
				{//HOLD_SERVICE
				MsgHoldService rmsg=(MsgHoldService) PrecRD.readObject();
				okmsgrcv=true;
				Log.netLogging(getName()+": receive HOLD_SERVICE");
				Log.netLogging("%% "+HostConfig.getPrecSock().toString());
				if (rmsg.getIPaddrCoordinator().equals(InetAddress.getLocalHost().getHostAddress()))
					{//generato da questo server --> vincente
					coo.setWinnerInsert(true);
					coo.getHolder().stop();
					Log.netLogging(getName()+": wait for end insert");
					try {coo.join();}
					catch (InterruptedException ei) {/*ignored*/}
					Log.netLogging(getName()+": resume!");
					}
				else
					{//non generato da questo server
					boolean coord=false;
					State ins=HostConfig.getCooIns();
					State hold=HostConfig.getHold();
					synchronized(hold)	{
					synchronized(ins)	{
						if (ins.isOff())
							{
							hold.TurnOn();
							coord=false;
							}
						else
							coord=true;
						}}
					if (!coord)
						{//non ha richieste di coordinamento di un inserimento
						//invio avanti (gi in hold=on)
						synchronized (SuccWR)
						//scrittura esclusiva per eventuali conflitti in scrittura
							{
							SuccWR.writeByte(typemsg);
							SuccWR.writeObject(rmsg);
							SuccWR.flush();
							}
						Log.netLogging(getName()+": forword HOLD_SERVICE");
						Log.netLogging("%% "+HostConfig.getSuccSock().toString());
						}
					else	//ha richieste di coordinamento di un inserimento
						if (HostConfig.getPriorityHost()<rmsg.getPriority())
							{//locale perdente
							coo.setWinnerInsert(false);
							coo.getHolder().stop();
							}
						//else scarta il messaggio arrivato (aspetta il suo)
					}
				}
			if (Message.decodeMsg(typemsg).equals("YPI"))
				{//YOUR_PRIORITY_IS
				MsgYourPriorityIs rmsg=(MsgYourPriorityIs) PrecRD.readObject();
				okmsgrcv=true;
				Log.netLogging(getName()+": receive YOUR_PRIORRITY_IS");
				Log.netLogging("%% "+HostConfig.getPrecSock().toString());
				//nuova priorit dell'host
				HostConfig.setPriorityHost(rmsg.getPriority());
				Log.netLogging(getName()+": set priority host "+rmsg.getPriority());
				//incrementa priorit nel messaggio
				rmsg.incPriority();
				//invio avanti
				synchronized (SuccWR)
					{
					SuccWR.writeByte(typemsg);
					SuccWR.writeObject(rmsg);
					SuccWR.flush();
					}
				Log.netLogging(getName()+": forword YOUR_PRIORITY_IS");
				Log.netLogging("%% "+HostConfig.getSuccSock().toString());
				}
			if (Message.decodeMsg(typemsg).equals("RSU"))
				{//RESURRECTION
				MsgResurrection rmsg=(MsgResurrection) PrecRD.readObject();
				okmsgrcv=true;
				Log.netLogging(getName()+": receive RESURRECTION");
				Log.netLogging("%% "+HostConfig.getPrecSock().toString());
				State hold=HostConfig.getHold();
				State ins=HostConfig.getCooIns();
				boolean ok=false;
				boolean res=false;
				synchronized(hold)	{
				synchronized(ins)	{
					if (ins.isOn())
						{//c' un coordinatore di inserimento su questo server
						res=true;
						coo.resume();
						}
					else	//nessun coordinatore
						if (hold.isOn())
							{//server in hold
							ok=true;
							hold.TurnOff();
							}
						//else	server non in hold
					}}
				if (res)
					;//server con coordinatore
				else
					if (ok)
						{//server in hold
						//invio avanti
						synchronized (SuccWR)
							{
							SuccWR.writeByte(typemsg);
							SuccWR.writeObject(rmsg);
							SuccWR.flush();
							}
						Log.netLogging(getName()+": forword RESURRECTION");
						Log.netLogging("%% "+HostConfig.getSuccSock().toString());	
						}
					else	; //server non in hold
				}
			if (Message.decodeMsg(typemsg).equals("AS"))
				{//ANCHOR_SERVER
				MsgAnchorServer rmsg=(MsgAnchorServer) PrecRD.readObject();
				okmsgrcv=true;
				Log.netLogging(getName()+": receive ANCHOR_SERVER");
				Log.netLogging("%% "+HostConfig.getPrecSock().toString());
				//creazione socket per nuovo predecessore
				Socket NewSock=new Socket(InetAddress.getByName(rmsg.getIPaddrNew()), CServer.PORTNEW);
				//riqualificazione connessioni con il predecessore
			//	HostConfig.redefineHostPrec(NewSock);
			
			/**/	ObjectOutputStream pwr=new ObjectOutputStream(NewSock.getOutputStream());
			/**/	pwr.flush();
			/**/	ObjectInputStream prd=new ObjectInputStream(NewSock.getInputStream());
			/**/	HostConfig.setPrecSock(NewSock);
			/**/	HostConfig.setPrecRD(prd);
			/**/	HostConfig.setPrecWR(pwr);
			
				HostConfig.getDeamonBook().redefinePrecHost();
				HostConfig.getDeamonCrash().redefinePrecHost();
				redefinePrecHost();
				Log.netLogging(getName()+": redefine predecessor connection");
				Log.netLogging("%% "+NewSock.toString());
				}
			if (!okmsgrcv)
			//altri casi
				Log.netLogging(getName()+": Protocol inconsistent");
				//bisogna fermare il server!!!!!!		
			}//end try
		catch (ClassNotFoundException e)	{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION]"+getName()+": "+e);}
		catch (OptionalDataException e)		{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION]"+getName()+": "+e);}
		catch (UnknownHostException e)		{Log.netLogging("($$$) [ADDRESS HOST EXCEPTION] "+getName()+": "+e);}
		catch (StreamCorruptedException e)	{Log.netLogging("($$$) [NEW INPUT OBJECT STREAM EXCEPTION] "+getName()+": "+e);}
		catch (EOFException e)			{/*ignored*/}
		catch (IOException e)			
			{
			Log.netLogging("($$$) [I/O EXCEPTION] "+getName()+": Problaby Ring Crash");
			Log.netLogging("#####################################################");
			Log.netLogging("#### "+getName()+": SYSTEM HALTED - Ring Crash #####");
			Log.netLogging("#####################################################");
			HostConfig.Halted();
			}
		} //end while
		}
	}