//ult. rev. 28/7/2000
//IMPLEMENTA LA RICHIESTA DI MODIFICA DEL DATABASE DISTRIBUITA
import java.io.IOException;

public class DistribuitedDB extends Thread
	{
	private ServerConfig HostConfig;
	private MessageDb smsg;
	private Db database;
	DistribuitedDB(ServerConfig c, MessageDb m)	
		{
		super("Distribuited-Db");
		HostConfig=c;
		smsg=m;
		database=HostConfig.getDatabase();
		}
		
	public void run()
		{
		DeamonBook forworder=HostConfig.getDeamonBook();
		//effettua modifica locale
		if (smsg instanceof MsgInsertFly)
			//inserimento nel database (se non c' posto dumpDB)
			database.addFlight(new FlightAttrib(((MsgInsertFly) smsg).getFlyId(), ((MsgInsertFly) smsg).getLeave(), ((MsgInsertFly) smsg).getArrive(), ((MsgInsertFly) smsg).getStartDate()));
		else
			if (smsg instanceof MsgDeleteFly)
				try {
				synchronized(database)		{
					int p=database.posFlight(((MsgDeleteFly) smsg).getFlyId());
					if (p>=0)
						database.delFlight(p);
					}
				}
				catch (Exception e) {/*impossibile*/}
		try {
		int num_ret=1;
		State hold=HostConfig.getHold();
		State unic=HostConfig.getUnic();
		boolean registry=false;
		boolean insert=false;
		while (true)	//ciclo infinito per ritrasmissioni
			{
			synchronized(hold)	{
			synchronized(unic)	{
				if (hold.isOn())		insert=true;//nessuna azione
				else
					{
					insert=false;
					if (unic.isOn())
						stop();
					else
						{
						if (!registry)
							{//registrazione al DeamonBook
							forworder.putRequestDB(this);
							registry=true;
							}
						//invio messaggio
						forworder.sendOnDirect(smsg.Byting());
						Log.srvLogging(getName()+": send messagge modify ["+num_ret+"]");
						num_ret++;
						}
					}
				}}
			if (insert)
				{//inserimento nuovo server in atto
				sleep(CServer.TIMEOUT_FOR_TURNOFFHOLD);
				yield();
				}
			else
				{//registrazione ed invio effettuati
				sleep(CServer.TIMEOUT_FOR_MODIFYDB);
				yield();
				}
			if (num_ret>CServer.MAX_RETRASMISSION)
				{
				Log.netLogging(getName()+" check ring status....");
				//generazione del ThreadDetect
				ThreadDetect td=new ThreadDetect(HostConfig);
				td.start();
				num_ret=1;
				sleep(CServer.TIMEOUT_FOR_CRASHDETECT);
				}
			} //end while
		} //end try
		catch (InterruptedException e) 	{Log.srvLogging("($$$) [INTERRUPTED] "+getName()+" "+e);}
		catch (IOException e)		{Log.srvLogging("($$$) [EXCEPTION ON SEND] "+getName()+" "+e);}
		}
	}