// ult. rev 27/07/2000
//IMPLEMENTA IL PROCESSO DI RICHIESTA DI PRENOTAZIONE DISTRIBUITA
import java.net.*;
import java.io.IOException;

public class DistribuitedDo extends Thread
	{
	private MsgDoBooking rmsg;		//messaggio sorgente (DO_BOOKING)
	private ServerConfig HostConfig;	//riferimento alla configurazione del server
	private Thread serv;			//riferimento al thread richiedente
	
	DistribuitedDo(MsgDoBooking m, Thread s, ServerConfig c)
		{
		super("Distribuited-Do");
		rmsg=m;
		HostConfig=c;
		serv=s;
		}
	//serve al DeamonBook per fornire la risposta al ThreadService	
	public synchronized Thread getService()	{return serv;}
	
	public void run()
		{
		try {
		DeamonBook forworder=HostConfig.getDeamonBook();
		//creazione richiesta di prenotazione per la coda del demone delle prenotazioni
		RequestThreadDo rtd=new RequestThreadDo(rmsg.getFlyId(),rmsg.getSeat()[0], rmsg.getSeat()[1], this);
		byte[] sdata=rmsg.Byting();	//messaggio di DO_BOOKING da spedire avanti 
						//conversione in array di byte
		boolean registry=false;		//indicatore di registrazione effettuata
		boolean insert=false;		//indicatore di server in hold
		int num_ret=1;			//numero di ritrasmissioni
		while (true)	//ciclo infinito
			{
			State hold=HostConfig.getHold();
			State unic=HostConfig.getUnic();
			synchronized(hold)	{
			synchronized(unic)	{
				if (hold.isOn())			insert=true;
				else
					{
					insert=false;
					if (unic.isOn())	{
							if (serv instanceof ThreadService)
								{
								//settaggio della risposta al ThreadService generatore
								MsgResponse msg=new MsgResponse(rtd.getFlightKey(), rtd.getSeat()[0], rtd.getSeat()[1], true, "DO");
								((ThreadService) serv).setResponse(msg);
								}
							//fine
							stop();
							}
					else			{
								if (!registry)
									{//inserimentto nella coda di DO
									registry=forworder.putRequestDo(rtd);
									yield();
									}
								//invio richiesta di DO
								forworder.sendOnDirect(sdata);
								Log.srvLogging(serv.getName()+" ("+getName()+") send DO_BOOKING ["+num_ret+"]");
								num_ret++;
								}
					}
				}}
			if (!registry)	
				{//registrazione non effettuata: coda piena
				sleep(CServer.TIMEOUT_FOR_INSERT_GROUPRQ);
				yield();
				}
			else
				if (insert)
					{//inserimento nuovo server in atto
					sleep(CServer.TIMEOUT_FOR_TURNOFFHOLD);
					yield();
					}
				else
					{//registrazione ed invio effettuati
					sleep(CServer.TIMEOUT_FOR_RETRASMISSION);
					yield();
					}
			if (num_ret>CServer.MAX_RETRASMISSION)
				{
				Log.netLogging(serv.getName()+" ("+getName()+") check ring status....");
				//generazione del ThreadDetect
				ThreadDetect td=new ThreadDetect(HostConfig);
				td.start();
				num_ret=1;
				sleep(CServer.TIMEOUT_FOR_CRASHDETECT);
				}
			}//end while
			}//end try
		catch (InterruptedException e) 	{Log.srvLogging("($$$) "+serv.getName()+" ("+getName()+") "+e);}
		catch (Exception e) 		{Log.srvLogging("($$$) "+serv.getName()+" ("+getName()+") "+e);}
		}
	}