//ult. rev. 13/06/2000
//IMPLEMENTAZIONE DELL'INSIEME DI RICHIESTE SOSPESE 

import Request;

public class GroupRequest
//INSIEME RICHIESTE
	{
	private int MAX_PENDING_RQ=50;
	//numero massimo di richieste pendenti
	private int NumRq;
	//numero di richieste pendenti significative
	private Request Pending[];
	//richieste pendenti
	
	GroupRequest()
		{
		NumRq=0;
		Pending=new Request[MAX_PENDING_RQ];
		}	
	GroupRequest(int np)
		{
		MAX_PENDING_RQ=np;
		NumRq=0;
		Pending=new Request[MAX_PENDING_RQ];
		}
		
	public synchronized int posRq(Request r)
	//RESTITUISCE LA POSIZIONE NEL GRUPPO DELLA RICHIESTA
		{
		for (int i=0; i<NumRq; i++)
			if (((Request) Pending[i]).Equals(r))
				return i;
		return -1;
		}
	public synchronized boolean putRq(Request r)
	//INSERISCE LA RICHIESTA
		{
		if (NumRq<MAX_PENDING_RQ)
			{
			NumRq++;
			Pending[NumRq-1]=r;
			return true;
			}
		else
			return false;
		}
	public synchronized boolean pushRq(int pos)
	//CANCELLA LA RICHIESTA
		{
		if (pos<NumRq)
			{
			Pending[pos]=Pending[NumRq-1];
			NumRq--;
			return true;
			}
		else 
			return false;
		}
	public synchronized Request getRq(int pos) throws Exception
	//RESTITUISCE LA RICHIESTA
		{
		if (pos<NumRq)
			return Pending[pos];
		else
			throw new ArrayIndexOutOfBoundsException("GroupRequest: Invalid Request Position");
		}
	public boolean isEmpty()
		{return (NumRq==0);}
	}