//13/06/2000
//IMPLEMENTA I TIPI DI MESSAGGIO SCAMBIABILI NEL SISTEMA
import java.io.Serializable;
import java.util.Date;

public abstract class Message implements Serializable
//CLASSE RADICE DI TUTTI I MESSAGGI CIRCOLANTI NELLA RETE
	{
	public static String decodeMsg(byte b)
		{
		switch (b)
			{
			case 0x01 : return ("DOB");	//DO_BOOKING
			case 0x02 : return ("UDB");	//UNDO_BOOKING
			case 0x03 : return ("DBO");	//DO_BOOKING_OVERRIDE
			case 0x04 : return ("GFL");	//GET_FLY_LIST
			case 0x05 : return ("FL");	//FLY_LIST
			case 0x06 : return ("GFS");	//GET_FREE_SEAT
			case 0x07 : return ("SL");	//SEAT_LIST
			case 0x08 : return ("BT");	//BOOKING_THIS
			case 0x09 : return ("GCFL");	//GET_CLIENT_FLY_LIST
			case 0x0A : return ("GCSL");	//GET_CLIENT_SEAT_LIST
			case 0x0B : return ("DB");	//DELETE_BOOKING
			case 0x0C : return ("RSP");	//RESPONSE
			
			case 0x0E: return ("AS");	//ANCHOR_SERVER
			case 0x0F: return ("HS");	//HOLD_SERVICE
			case 0x10: return ("YPI");	//YOUR_PRIORITY_IS
			case 0x11: return ("CSD");	//CRASH_SERVER_DETECT
			case 0x12: return ("RSU");	//RESURRECTION
			
			case 0x14: return ("IFY");	//INSERT_FLY
			case 0x15: return ("DFY");	//DELETE_FLY
			case 0x16: return ("OD");	//ORIGIN_DETECT
			case 0x17: return ("db");		//database
			default : return ("UKW");	//unknow
			}
		}
	public static byte codeMsg(String s)
		{
		if (s.equals("DOB") )	return ((byte) 0x01);
		if (s.equals("UDB"))	return ((byte) 0x02);
		if (s.equals("DBO"))	return ((byte) 0x03);
		if (s.equals("GFL"))	return ((byte) 0x04);
		if (s.equals("FL"))	return ((byte) 0x05);
		if (s.equals("GFS"))	return ((byte) 0x06);
		if (s.equals("SL"))	return ((byte) 0x07);
		if (s.equals("BT"))	return ((byte) 0x08);
		if (s.equals("GCFL"))	return ((byte) 0x09);
		if (s.equals("GCSL"))	return ((byte) 0x0A);
		if (s.equals("DB"))	return ((byte) 0x0B);
		if (s.equals("RSP"))	return ((byte) 0x0C);

		if (s.equals("AS"))	return ((byte) 0x0E);
		if (s.equals ("HS"))	return ((byte) 0x0F);
		if (s.equals("YPI"))	return ((byte) 0x10);
		if (s.equals("CSD"))	return ((byte) 0x11);
		if (s.equals("RSU"))	return ((byte) 0x12);
		
		if (s.equals("IFY"))	return ((byte) 0x14);
		if (s.equals ("DFY")) 	return ((byte) 0x15);
		if (s.equals ("OD")) 	return ((byte) 0x16);
		if (s.equals ("db"))	return ((byte) 0x17);
		return ((byte) 0x00);
		}
	}
	
abstract class MessageUDP extends Message
	{
	public abstract byte[] Byting();
	}
	
	abstract class MessageRq extends MessageUDP
	//MESSAGGI DI RICHIESTA SULLE PRENOTAZIONI (circolanti tra server)
		{
		protected FlightKey FlyId;
		protected int[] Seat;
		protected String IPaddrSender;
	
		MessageRq()
			{Seat=new int[2];}
		MessageRq(FlightKey f, int rs, int ns,  String ip)
			{
			FlyId=f;
			Seat=new int[2];
			Seat[0]=rs;
			Seat[1]=ns;
			IPaddrSender=ip;
			}
			
		public FlightKey getFlyId()		{return FlyId;}
		public int[] getSeat()			{return Seat;}
		public String getIPaddrSender()		{return IPaddrSender;}
			
		public void setFlyId(FlightKey fi)	{FlyId=fi;}
		public void setSeat(int r, int n)
			{
			Seat[0]=r;
			Seat[1]=n;
			}
		public void setIPaddrSender(String ip)		{IPaddrSender=ip;}
		
		public abstract byte[] Byting();
		}
	
		class MsgDoBooking extends MessageRq
		//MESSAGGIO DI RICHIESTA PRENOTAZIONE
			{
			protected int Priority;
			protected ClientAttrib Client;
			
			MsgDoBooking()		{}
			MsgDoBooking(FlightKey f, int rs, int ns, ClientAttrib ci, String ip, int p)
				{
				super(f, rs, ns, ip);
				Client=ci;
				Priority=p;
				}
					
			public byte[] Byting()
				{
				byte[] code=new byte[1];
				code[0]=Message.codeMsg("DOB");
				byte[] b2=Pack.Bytinginteger(Seat[0]);
				byte[] b3=Pack.Bytinginteger(Seat[1]);
				byte[] b4=Pack.Bytingstring(IPaddrSender);
				byte[] b5=Pack.UniqueByting(FlyId.Byting(), Pack.UniqueByting(b2, Pack.UniqueByting(b3, b4)));
				return Pack.UniqueByting(code, Pack.UniqueByting(b5, Pack.UniqueByting(Client.Byting(), Pack.Bytinginteger(Priority))));
				}
				
			public static MsgDoBooking UnByting(byte[] rapp)
				{
				//salto il byte di identificazione
				int counter=1;
				//chiave volo
				byte[] b1=new byte[8];
				for (int i=0; i<8; i++)			b1[i]=rapp[i+counter];
				counter +=8;
				//indicativo fila posto		
				byte[] b2=new byte[4];
				for (int i=0; i<4; i++)			b2[i]=rapp[i+counter];
				counter +=4;
				//indicativo numero posto
				byte[] b3=new byte[4];
				for (int i=0; i<4; i++)			b3[i]=rapp[i+counter];
				counter +=4;
				//lunghezza stringa ip
				byte[] b7=new byte[4];
				for (int i=0; i<4; i++)			b7[i]=rapp[i+counter];
				counter +=4;
				int len2=Pack.UnBytinginteger(b7);
				//stringa ip	
				byte[] b8=new byte[len2];
				for (int i=0; i<len2; i++)			b8[i]=rapp[i+counter];
				counter +=len2;
				//chiave cliente
				byte[] b4=new byte[8];
				for (int i=0; i<8; i++)			b4[i]=rapp[i+counter];
				counter +=8;
				//lunghezza stringa cliente
				byte[] b5=new byte[4];
				for (int i=0; i<4; i++)			b5[i]=rapp[i+counter];
				counter +=4;
				int len=Pack.UnBytinginteger(b5);
				//stringa cliente	
				byte[] b6=new byte[len];
				for (int i=0; i<len; i++)			b6[i]=rapp[i+counter];
				counter +=len;
				//priorit
				byte[] b9=new byte[4];
				for (int i=0; i<4; i++)			b9[i]=rapp[i+counter];
				counter +=4;
				byte[] b10=Pack.UniqueByting(b4,Pack.UniqueByting(b5,b6));
				return new MsgDoBooking(FlightKey.UnByting(b1), Pack.UnBytinginteger(b2), Pack.UnBytinginteger(b3), ClientAttrib.UnByting(b10), Pack.UnBytingstring(b8), Pack.UnBytinginteger(b9));
				}
				
			public int getPriority()		{return Priority;}
			public ClientAttrib getClient()	{return Client;}
			public void setPriority(int prio)	{Priority=prio;}
			public void setClient(ClientAttrib c)	{Client=c;}
			}
			
		class MsgUndoBooking extends MessageRq
		//MESSAGGIO DI CANCELLAZIONE PRENOTAZIONE
			{
			protected ClientKey ClientK;
			
			MsgUndoBooking()		{ }
			MsgUndoBooking(FlightKey f, int rs, int ns, ClientKey ci, String ip)		{super(f, rs, ns, ip); ClientK=ci;}
		//	MsgUndoBooking(MsgDoBooking m) 						
		//		{super (m.getFlyId(), m.getSeat()[0], m.getSeat()[1], m.getIPaddrSender()); ClientK=m.getClient().getClientKey();}
		//	MsgUndoBooking(MsgDoBookingOverride m) 						
		//		{super (m.getFlyId(), m.getSeat()[0], m.getSeat()[1], m.getIPaddrSender()); ClientK=m.getClient().getClientKey();}
			
			public ClientKey getClientId()		{return ClientK;}
			public void setClientId(ClientKey k)	{ClientK=k;}
			
			public byte[] Byting()
				{
				byte[] code=new byte[1];
				code[0]=Message.codeMsg("UDB");
				byte[] b2=Pack.Bytinginteger(Seat[0]);
				byte[] b3=Pack.Bytinginteger(Seat[1]);
				byte[] b4=Pack.Bytingstring(IPaddrSender);
				byte[] b5=Pack.UniqueByting(FlyId.Byting(), Pack.UniqueByting(b2, Pack.UniqueByting(b3, b4)));
				return Pack.UniqueByting(code, Pack.UniqueByting( b5, ClientK.Byting()));
				}
				
			public static MsgUndoBooking UnByting(byte[] rapp)
				{
				//salto il byte di identificazione
				int counter=1;
				//chiave volo
				byte[] b1=new byte[8];
				for (int i=0; i<8; i++)			b1[i]=rapp[i+counter];
				counter +=8;
				//indicativo fila posto		
				byte[] b2=new byte[4];
				for (int i=0; i<4; i++)			b2[i]=rapp[i+counter];
				counter +=4;
				//indicativo numero posto
				byte[] b3=new byte[4];
				for (int i=0; i<4; i++)			b3[i]=rapp[i+counter];
				counter +=4;
				//lunghezza stringa ip
				byte[] b7=new byte[4];
				for (int i=0; i<4; i++)			b7[i]=rapp[i+counter];
				counter +=4;
				int len2=Pack.UnBytinginteger(b7);
				//stringa ip	
				byte[] b8=new byte[len2];
				for (int i=0; i<len2; i++)		b8[i]=rapp[i+counter];
				counter +=len2;
				//chiave cliente
				byte[] b4=new byte[8];
				for (int i=0; i<8; i++)			b4[i]=rapp[i+counter];
				counter +=8;
				return new MsgUndoBooking(FlightKey.UnByting(b1), Pack.UnBytinginteger(b2), Pack.UnBytinginteger(b3), ClientKey.UnByting(b4), Pack.UnBytingstring(b8));
				}
			}
			
		class MsgDoBookingOverride extends MessageRq
		//MESSAGGIO DI SOVRASCRITTURA PRENOTAZIONE
			{
			protected ClientAttrib Client;
			MsgDoBookingOverride()		{ }
			MsgDoBookingOverride(FlightKey f, int rs, int ns, ClientAttrib ci, String ip)		{super(f, rs, ns, ip); Client=ci;}
			MsgDoBookingOverride(MsgDoBooking m)	{super(m.getFlyId(), m.getSeat()[0], m.getSeat()[1], m.getIPaddrSender()); Client=m.getClient();}
				
			public byte[] Byting()
				{
				byte[] code=new byte[1];
				code[0]=Message.codeMsg("DBO");
				byte[] b2=Pack.Bytinginteger(Seat[0]);
				byte[] b3=Pack.Bytinginteger(Seat[1]);
				byte[] b4=Pack.Bytingstring(IPaddrSender);
				byte[] b5=Pack.UniqueByting(FlyId.Byting(), Pack.UniqueByting(b2, Pack.UniqueByting(b3, b4)));
				return Pack.UniqueByting(code, Pack.UniqueByting(b5, Client.Byting()));
				}
				
			public static MsgDoBookingOverride UnByting(byte[] rapp)
				{
				//salto il byte di identificazione
				int counter=1;
				//chiave volo
				byte[] b1=new byte[8];
				for (int i=0; i<8; i++)			b1[i]=rapp[i+counter];
				counter +=8;
				//indicativo fila posto		
				byte[] b2=new byte[4];
				for (int i=0; i<4; i++)			b2[i]=rapp[i+counter];
				counter +=4;
				//indicativo numero posto
				byte[] b3=new byte[4];
				for (int i=0; i<4; i++)			b3[i]=rapp[i+counter];
				counter +=4;
				//lunghezza stringa ip
				byte[] b7=new byte[4];
				for (int i=0; i<4; i++)			b7[i]=rapp[i+counter];
				counter +=4;
				int len2=Pack.UnBytinginteger(b7);
				//stringa ip	
				byte[] b8=new byte[len2];
				for (int i=0; i<len2; i++)			b8[i]=rapp[i+counter];
				counter +=len2;
				//chiave cliente
				byte[] b4=new byte[8];
				for (int i=0; i<8; i++)			b4[i]=rapp[i+counter];
				counter +=8;
				//lunghezza stringa cliente
				byte[] b5=new byte[4];
				for (int i=0; i<4; i++)			b5[i]=rapp[i+counter];
				counter +=4;
				int len=Pack.UnBytinginteger(b5);
				//stringa cliente	
				byte[] b6=new byte[len];
				for (int i=0; i<len; i++)			b6[i]=rapp[i+counter];
				counter +=len;
				byte[] b10=Pack.UniqueByting(b4,Pack.UniqueByting(b5,b6));
				return new MsgDoBookingOverride(FlightKey.UnByting(b1), Pack.UnBytinginteger(b2), Pack.UnBytinginteger(b3), ClientAttrib.UnByting(b10), Pack.UnBytingstring(b8));
				}
				
			public ClientAttrib getClient()		{return Client;}
			public void setClient(ClientAttrib c)	{Client=c;}
			}
	
	abstract class MessageDb extends MessageUDP
	//MESSAGGI PER LA MODIFICA DEL DATABASE
		{
		public abstract byte[] Byting();
		}
		
		class MsgInsertFly extends MessageDb
			{
			private FlightKey FlyId;
			private String LeaStr;
			private String ArrStr;
			private Date StartD;
			private String IPaddrIns;
			
			MsgInsertFly(FlightKey f, String l, String a, Date d, String ip)
				{
				FlyId=f;
				LeaStr=l;
				ArrStr=a;
				StartD=d;
				IPaddrIns=ip;
				}
				
			public FlightKey getFlyId()		{return FlyId;}
			public String getLeave()			{return LeaStr;}
			public String getArrive()			{return ArrStr;}
			public Date getStartDate()		{return StartD;}
			public String getIPaddrInsert()		{return IPaddrIns;}
				
			public void setFlyId(FlightKey f)			{FlyId=f;}
			public void setLeave(String l)			{LeaStr=l;}
			public void setArrive(String l)			{ArrStr=l;}
			public void setStartDate(Date d)			{StartD=d;}
			public void setIPaddrInsert(String ip)		{IPaddrIns=ip;}
			
			public byte[] Byting()
				{
				byte[] code=new byte[1];
				code[0]=Message.codeMsg("IFY");
				byte[] b2=Pack.Bytingstring(LeaStr);
				byte[] b3=Pack.Bytingstring(ArrStr);
				byte[] b4=Pack.Bytinglong(StartD.getTime());
				byte[] b5=Pack.Bytingstring(IPaddrIns);
				return Pack.UniqueByting(code, Pack.UniqueByting(FlyId.Byting(), Pack.UniqueByting(b2, Pack.UniqueByting(b3, Pack.UniqueByting (b4, b5)))));
				}
				
			public static MsgInsertFly UnByting(byte[] rapp)
				{
				//salto il byte di identificazione
				int counter=1;
				//chiave volo
				byte[] b1=new byte[8];
				for (int i=0; i<8; i++)			b1[i]=rapp[i+counter];
				counter +=8;
				//lunghezza stringa partenza		
				byte[] b2=new byte[4];
				for (int i=0; i<4; i++)			b2[i]=rapp[i+counter];
				counter +=4;
				int ls=Pack.UnBytinginteger(b2);
				//stringa partenza
				byte[] b3=new byte[ls];
				for (int i=0; i<ls; i++)			b3[i]=rapp[i+counter];
				counter +=ls;
				//lunghezza stringa arrivo
				byte[] b4=new byte[4];
				for (int i=0; i<4; i++)			b4[i]=rapp[i+counter];
				counter +=4;
				int as=Pack.UnBytinginteger(b4);
				//stringa arrivo
				byte[] b5=new byte[as];
				for (int i=0; i<as; i++)			b5[i]=rapp[i+counter];
				counter +=as;
				//data (in time)
				byte[] b6=new byte[8];
				for (int i=0; i<8; i++)			b6[i]=rapp[i+counter];
				counter +=8;
				//lunghezza stringa ip
				byte[] b7=new byte[4];
				for (int i=0; i<4; i++)			b7[i]=rapp[i+counter];
				counter +=4;
				int ipl=Pack.UnBytinginteger(b7);
				//stringa ip	
				byte[] b8=new byte[ipl];
				for (int i=0; i<ipl; i++)			b8[i]=rapp[i+counter];
				counter +=ipl;
				return new MsgInsertFly(FlightKey.UnByting(b1), Pack.UnBytingstring(b3), Pack.UnBytingstring(b5), new Date(Pack.UnBytinglong(b6)), Pack.UnBytingstring(b8));
				}
			}
			
		class MsgDeleteFly extends MessageDb
			{
			private FlightKey FlyId;
			private String IPaddrDel;
			
			MsgDeleteFly(FlightKey f, String ip)
				{
				FlyId=f;
				IPaddrDel=ip;
				}
				
			public FlightKey getFlyId()		{return FlyId;}
			public String getIPaddrDelete()		{return IPaddrDel;}
				
			public void setFlyId(FlightKey f)			{FlyId=f;}
			public void setIPaddrDelete(String ip)		{IPaddrDel=ip;}
			
			public byte[] Byting()
				{
				byte[] code=new byte[1];
				code[0]=Message.codeMsg("DFY");
				byte[] b2=Pack.Bytingstring(IPaddrDel);
				return Pack.UniqueByting(code, Pack.UniqueByting(FlyId.Byting(), b2));
				}
				
			public static MsgDeleteFly UnByting(byte[] rapp)
				{
				//salto il byte di identificazione
				int counter=1;
				//chiave volo
				byte[] b1=new byte[8];
				for (int i=0; i<8; i++)			b1[i]=rapp[i+counter];
				counter +=8;
				//lunghezza stringa ip
				byte[] b7=new byte[4];
				for (int i=0; i<4; i++)			b7[i]=rapp[i+counter];
				counter +=4;
				int ipl=Pack.UnBytinginteger(b7);
				//stringa ip	
				byte[] b8=new byte[ipl];
				for (int i=0; i<ipl; i++)			b8[i]=rapp[i+counter];
				counter +=ipl;
				return new MsgDeleteFly(FlightKey.UnByting(b1), Pack.UnBytingstring(b8));
				}
			}
				
	
abstract class MessageTCP extends Message
	{	}
	
	abstract class MessageSrv extends MessageTCP
	//MESSAGGI DI RICHIESTA DEI SERVIZI (interazione client-server)
		{	}	
	
		class MsgGetFlyList extends MessageSrv
			{
			MsgGetFlyList()		{ }
			}
		class MsgFlyList extends MessageSrv
			{
			private FlightAttrib[] Listed;	//lista degli attributi dei voli presenti
			
			MsgFlyList()			{ }
			MsgFlyList(FlightAttrib[] f)	{Listed=f;}
			
			public FlightAttrib[] getList()			{return Listed;}
			public void setList(FlightAttrib[] l)		{Listed=l;}
			}
		class MsgGetFreeSeat extends MessageSrv
			{
			private FlightKey CodF;		//codice del volo
			
			MsgGetFreeSeat()			{ }
			MsgGetFreeSeat(FlightKey cf)		{CodF=cf;}
				
			public FlightKey getFlyId()			{return CodF;}
			public void setFlyId(FlightKey k)		{CodF=k;}
			}
			
		class MsgSeatList extends MessageSrv
			{
			private int[] Listed;
			private FlightKey FlyId;
			private int n_row;
			private int n_num;
			
			MsgSeatList()			{ }
			MsgSeatList(FlightKey f, int[] l, int nr, int nn)
				{
				FlyId=f;
				Listed=l;
				n_row=nr;
				n_num=nn;
				}
			
			public int[] getList()			{return Listed;}
			public FlightKey getFlyId()		{return FlyId;}
			public int getNumR()			{return n_row;}
			public int getNumN()			{return n_num;}
			public void setList(int[] l)		{Listed=l;}
			public void setFlyId(FlightKey f)		{FlyId=f;}
			public void setNumR(int r)		{n_row=r;}
			public void setNumN(int n)		{n_num=n;}
			}
			
		class MsgGetClientFlyList extends MessageSrv
			{
			private ClientKey CodC;
			
			MsgGetClientFlyList()				{ }
			MsgGetClientFlyList(ClientKey c)		{CodC=c;}
			
			public ClientKey getClientId()			{return CodC;}	
			public void setClientId(ClientKey k)		{CodC=k;}
			}
			
		class MsgGetClientSeatList extends MessageSrv
			{
			private ClientKey CodC;
			private FlightKey CodF;
			
			MsgGetClientSeatList()		{ }
			MsgGetClientSeatList(ClientKey c, FlightKey f)
				{
				CodC=c;
				CodF=f;
				}
				
			public ClientKey getClientId()			{return CodC;}	
			public void setClientId(ClientKey k)		{CodC=k;}
			public FlightKey getFlyId()			{return CodF;}	
			public void setFlyId(FlightKey k)		{CodF=k;}
			}
			
		class MsgResponse extends MessageSrv
			{
			private FlightKey CodF;
			private int[] Seat;
			private String Desc;
			private boolean OK;
			
			MsgResponse()			{Seat=new int[2];}
			MsgResponse(FlightKey k, int r, int n, boolean b, String s)
				{
				CodF=k;
				Seat=new int[2];
				Seat[0]=r;
				Seat[1]=n;
				OK=b;
				Desc=s;
				}
			
			public FlightKey getFlyId()			{return CodF;}
			public int[] getSeat()				{return Seat;}
			public boolean isSuccesseful()			{return OK;}
			public String getDescription()			{return Desc;}
			public void setFlyId(FlightKey k)		{CodF=k;}
			public void setSeat(int r, int n)			{Seat[0]=r; Seat[1]=n;}
			public void setSuccesseful(boolean b)		{OK=b;}
			public void setDescription(String s)		{Desc=s;}
			}
		
		abstract class MessageBook extends MessageSrv
			{
			private FlightKey CodF;
			private int[] Seat;
			
			MessageBook()		{Seat=new int[2];}
			MessageBook(FlightKey f, int r, int n)
				{
				Seat=new int[2];
				CodF=f;
				Seat[0]=r;
				Seat[1]=n;
				}
				
			public FlightKey getFlyId()			{return CodF;}
			public int[] getSeat()				{return Seat;}
			public void setFlyId(FlightKey k)		{CodF=k;}
			public void setSeat(int r, int n)
				{
				Seat[0]=r;
				Seat[1]=n;
				}
			}
	
			class MsgBookingThis extends MessageBook
				{
				private ClientAttrib Client;
				
				MsgBookingThis()		{super();}
				MsgBookingThis(FlightKey f, int r, int n, ClientAttrib c)
					{
					super(f,r,n);
					Client=c;
					}
					
				public ClientAttrib getClient()			{return Client;}
				public void setClient(ClientAttrib c)		{Client=c;}
				}
				
			class MsgDeleteBooking extends MessageBook
				{
				private ClientKey CodC;
				
				MsgDeleteBooking()		{super();}
				MsgDeleteBooking(FlightKey f, int r, int n, ClientKey c)
					{
					super(f,r,n);
					CodC=c;
					}
					
				public ClientKey getClientId()			{return CodC;}
				public void setClientId(ClientKey c)		{CodC=c;}
				}

	abstract class MessageNet extends MessageTCP
	//MESSAGGIO PER IL CONTROLLO DELLE CONNESSIONI
		{}
		
		class MsgCrashServerDetect extends MessageNet
			{
			private String IPaddrRil;
			private String IPaddrCrash;
			
			MsgCrashServerDetect(String r, String c)
				{
				IPaddrRil=r;
				IPaddrCrash=c;
				}
				
			public String getIPaddrRilevator()		{return IPaddrRil;}
			public String getIPaddrCrash()			{return IPaddrCrash;}
			public void setIPaddrRilevator(String r)		{IPaddrRil=r;}
			public void setIPaddrCrash(String c)		{IPaddrCrash=c;}
			}
			
		class MsgOriginDetect extends MessageNet
			{
			private String IPaddrOrig;
			
			MsgOriginDetect(String o)			{IPaddrOrig=o;}
				
			public String getIPaddrOrigin()			{return IPaddrOrig;}
			public void setIPaddrOrigin(String c)		{IPaddrOrig=c;}
			}
			
		class MsgHoldService extends MessageNet
			{
			private String IPaddrCoo;
			private int prio;
			
			MsgHoldService(String c, int p)			{IPaddrCoo=c; prio=p;}
				
			public String getIPaddrCoordinator()		{return IPaddrCoo;}
			public int getPriority()				{return prio;}
			public void setIPaddrCoordinator(String c)	{IPaddrCoo=c;}
			public void setPriority(int p)			{prio=p;}
			}
			
		class MsgAnchorServer extends MessageNet
			{
			private String IPaddrNew;
			
			MsgAnchorServer(String c)			{IPaddrNew=c;}
				
			public String getIPaddrNew()			{return IPaddrNew;}
			public void setIPaddrNew(String c)		{IPaddrNew=c;}
			}
		
		class MsgYourPriorityIs extends MessageNet
			{
			private String IPaddrCoo;
			private int Prio;
			
			MsgYourPriorityIs (String c, int p)
				{
				IPaddrCoo=c;
				Prio=p;
				}
				
			public String getIPaddrCoordinator()		{return IPaddrCoo;}
			public int getPriority()				{return Prio;}
			public void setIPaddrCoordinator(String c)	{IPaddrCoo=c;}
			public void setPriority(int p)			{Prio=p;}
			public void incPriority()				{Prio++;}
			}
			
		class MsgResurrection extends MessageNet
			{
			private String IPaddrGen;
	
			MsgResurrection (String g)			{IPaddrGen=g;}
				
			public String getIPaddrGenerator()		{return IPaddrGen;}
			public void setIPaddrGenerator(String g)		{IPaddrGen=g;}
			}

		
		