//21/06/2000
//utilma rev. 27/9/2000
//IMPLEMENTA L'OGGETTO DI CONFIGURAZIONE DEL SERVER (UNICO NEL SISTEMA)
import java.net.*;
import java.io.*;

public class ServerConfig
	{
	//variabili di stato del server
	private State unic;		//stato di server unico
	private State hold;		//stato di hold
	private State detect;		//stato di coordinatore di un crash
	private State ins;			//stato di coordinatore di un inserimento
	private State crash;		//stato di crash in atto
	private int prio;			//priorit del server
	private Db d_base;		//riferimento al database
	private Socket socksucc;			//socket TCP con l'host successivo
	private Socket sockprec;			//socket TCP con l'host precedente
	private DatagramSocket sockd;		//socket UDP
	private ObjectOutputStream hostsuccWR, hostprecWR; 	//stream delle socket in scrittura
	private ObjectInputStream hostsuccRD, hostprecRD;	//stream delle socket in lettura
	private DeamonInsert d_ins;		//riferimento al demone di inserimento
	private DeamonRequest d_rq;		//riferimento al demone delle richieste
	private DeamonCrash d_crs;		//riferimento al demone di crash
	private DeamonCrashDetect d_crs_d;	//riferimento al demone di crash-detect
	private DeamonNetwork d_net;		//riferimento al demone di rete
	private DeamonBook d_book;		//riferimento al demone delle prenotazioni
	private InterfaceServer app;		//riferimento all'applicazione server

	ServerConfig()	{unic=new State(); hold=new State(); detect=new State(); ins=new State(); crash=new State();}
		
	public void Halted()
		{
		app.Ender();
		try { getDeamonInsert().stop();}
		catch (Exception e) {/*ignored*/}
		try { getDeamonRequest().stop();}
		catch (Exception e) {/*ignored*/}
		try { getDeamonCrash().stop();
}
		catch (Exception e) {/*ignored*/}
		try { getDeamonCrashDetect().stop();
}
		catch (Exception e) {/*ignored*/}
		try { getDeamonNetwork().stop();
}
		catch (Exception e) {/*ignored*/}
		try { getDeamonBook().stop();}
		catch (Exception e) {/*ignored*/}
		try { socksucc.close();
}
		catch (Exception e) {/*ignored*/}
		try { sockprec.close();
}
		catch (Exception e) {/*ignored*/}
		try { sockd.close(); }
		catch (Exception e) {/*ignored*/}
		}
	
	//procedure di cambiamento dello stato del server
	public State getHold()		{return hold;}
	public State getUnic()		{return unic;}
	public State getDetect()		{return detect;}
	public State getCooIns()		{return ins;}
	public State getCrash()		{return crash;}
	public int getPriorityHost()	{return prio;}
	
	public synchronized void setPriorityHost(int p)			{prio=p;}
	
	//restituzione riferimenti ai demoni	
	public DeamonInsert getDeamonInsert()					{return d_ins;}
	public DeamonRequest getDeamonRequest()				{return d_rq;}
	public DeamonCrash getDeamonCrash()					{return d_crs;}
	public DeamonCrashDetect getDeamonCrashDetect()			{return d_crs_d;}
	public DeamonNetwork getDeamonNetwork()				{return d_net;}
	public DeamonBook getDeamonBook()					{return d_book;}
	public Db getDatabase()							{return d_base;}
	//settaggio riferimenti a demoni
	public synchronized void setDeamonInsert(DeamonInsert g)			{d_ins=g;}
	public synchronized void setDeamonRequest(DeamonRequest g)			{d_rq=g;}
	public synchronized void setDeamonCrash(DeamonCrash g)			{d_crs=g;}
	public synchronized void setDeamonCrashDetect(DeamonCrashDetect g)		{d_crs_d=g;}
	public synchronized void setDeamonNetwork(DeamonNetwork g)		{d_net=g;}
	public synchronized void setDeamonBook(DeamonBook g)			{d_book=g;}
	public synchronized void setDatabase(Db g)					{d_base=g;}
	public synchronized void setApplication(InterfaceServer t)			{app=t;}
	//restituzione degli indirizzi dei server connessi
	public InetAddress getSuccHost()			{return socksucc.getInetAddress();}
	public InetAddress getPrecHost()			{return sockprec.getInetAddress();}
	//restituzioni degli stream di comunicazione con i server vicini
	public ObjectOutputStream getSuccWR()			{return hostsuccWR;}
	public ObjectOutputStream getPrecWR()			{return hostprecWR;}
	public ObjectInputStream getSuccRD()			{return hostsuccRD;}
	public ObjectInputStream getPrecRD()			{return hostprecRD;}
	//restituzione socket di connessione con i server vicini
	public Socket getSuccSock()				{return socksucc;}
	public Socket getPrecSock()				{return sockprec;}
	//settaggi degli stream di comunicazione con i server vicini
	public void setSuccWR(ObjectOutputStream swr)		{hostsuccWR=swr;}
	public void setPrecWR(ObjectOutputStream pwr)		{hostprecWR=pwr;}
	public void setSuccRD(ObjectInputStream srd)		{hostsuccRD=srd;}
	public void setPrecRD(ObjectInputStream prd)		{hostprecRD=prd;}
	//settaggio socket di connessione con i server vicini
	public void setSuccSock(Socket s)			{socksucc=s;}
	public void setPrecSock(Socket p)			{sockprec=p;}
	}