//ult. rev. 28/07/2000
//IMPLEMENTA IL GESTORE DI CRASH
import java.io.*;
import java.net.*;

public class ThreadCrash extends Thread
	{
	private ServerConfig HostConfig;
	ThreadCrash(ServerConfig c)	{super("Thread-CRASH"); HostConfig=c;}
	public void run()
		{
		Log.netLogging("********** CRASH DETECT **********");
		Log.srvLogging("********** CRASH DETECT **********");
		State hold=HostConfig.getHold();
		State unic=HostConfig.getUnic();
		State crash=HostConfig.getCrash();
		// accesso esclusivo agli stati del sistema
		synchronized(hold)	{
		synchronized(unic)	{
		synchronized(crash)	{
			if (hold.isOn())
			//sistema in hold (inserimento in atto)
				{
				Log.netLogging("######################################");
				Log.netLogging("#### "+getName()+": SYSTEM HALTED #####");
				Log.netLogging("######################################");
				HostConfig.Halted();
				stop();
				}
			else
	
			//sistema non in hold (nessun inserimento in atto)
				{
				crash.TurnOn();
				// settaggio dello stato di crash
				if (HostConfig.getSuccHost().getHostAddress().equals(HostConfig.getPrecHost().getHostAddress()))
					{
					//solo 2 server
					unic.TurnOn();
					// settaggio stato di server unico
					Log.netLogging("(! ! !) "+getName()+": Server UNIC-ON");
					// stop dei demoni non utilizzati in configurazione unica
					HostConfig.getDeamonBook().stop();
					HostConfig.getDeamonNetwork().stop();
					HostConfig.getDeamonCrashDetect().stop();
					Log.netLogging(getName()+": Daemon Book, Network & Crash-Detect stopped");
					Log.netLogging(getName()+": stop");
					Log.netLogging("******** RECOVERY RING FINISH ********");
					Log.srvLogging("******** RECOVERY RING FINISH ********");
					crash.TurnOff();
					Log.netLogging("(! ! !) "+getName()+": Server UNIC-OFF");
					// resettaggio stato di crash
					stop();
					}
				}
			}}}
		try{
			//pi di 2 server nel sistema
			//(arriva qui solo in questo caso)
			//creazione messaggio di CRASH_DETECT
			MsgCrashServerDetect smsg=new MsgCrashServerDetect(InetAddress.getLocalHost().getHostAddress(), HostConfig.getSuccHost().getHostAddress());
			//invio del messaggio indietro (connessione del deamon-crash)
			ObjectOutputStream PrecWR=HostConfig.getPrecWR();
			synchronized (PrecWR)
			//scrittura atomica ed eslusiva sullo stream
				{
				PrecWR.writeByte(Message.codeMsg("CSD"));
				PrecWR.writeObject(smsg);
				PrecWR.flush();
				}
			//nuova socket d'ascolto per il nuovo successore
			ServerSocket LstSucc=new ServerSocket(CServer.PORTNEW);
			Log.netLogging(getName()+": socket listen for new successor");
			Socket NewSock=LstSucc.accept();
			Log.netLogging(getName()+": new successor");
			Log.netLogging("%% "+NewSock.toString());
			//ridefinizione riferimenti al successore
			ObjectOutputStream SuccWR=new ObjectOutputStream(NewSock.getOutputStream());
			SuccWR.flush();
			ObjectInputStream SuccRD=new ObjectInputStream(NewSock.getInputStream());
		/**/	HostConfig.getSuccSock().close();
		/**/	HostConfig.setSuccSock(NewSock);
		/**/	HostConfig.setSuccWR(SuccWR);
		/**/	HostConfig.setSuccRD(SuccRD);
			HostConfig.getDeamonBook().redefineSuccHost();
			HostConfig.getDeamonNetwork().redefineSuccHost();
			HostConfig.getDeamonCrash().redefineSuccHost();
			Log.netLogging(getName()+": redefine successor connection");
			Log.netLogging("******** RECOVERY RING FINISH ********");
			Log.srvLogging("******** RECOVERY RING FINISH ********");
			crash.TurnOff();
			// resettaggio stato di crash
			}//end try
		catch (IOException e2) {Log.netLogging(" ($$$) "+getName()+":  "+e2);}
		}
	}
