//28/06/2000
//IMPLEMENTA IL PROCESSO DI DETECT DI UN CRASH
import java.net.*;
import java.io.*;

public class ThreadDetect extends Thread
	{
	private ServerConfig HostConfig;	//riferimento all'oggetto di stato del server
	private MsgOriginDetect smsg;
	
	ThreadDetect(ServerConfig s)	
		{
		super("Thread-DETECT"); 
		HostConfig=s;
		try {smsg=new MsgOriginDetect(InetAddress.getLocalHost().getHostAddress());}
		catch(UnknownHostException e) {/*ignored*/}
		}
		
	ThreadDetect(ServerConfig s, MsgOriginDetect m)
		{
		super(" THREAD DETECT"); 
		HostConfig=s;
		smsg=m;
		} 
	
	public void run()
		{
		State detect=HostConfig.getDetect();
		boolean go=false;
		synchronized(detect)	{
			if (detect.isOn())	;//fine processo
			else
				{
				go=true;
				detect.TurnOn();
				Log.netLogging("(! ! !) "+getName()+" server DETECT-ON");
				}
			}//end synch
		if (go)
			{
			try {
				Log.netLogging(getName()+" test");
				Log.srvLogging(getName()+" test");
				//tentativo di connessione alla sochet di detect (demone di detect)
				Socket DetSock=new Socket(HostConfig.getSuccHost(), 9998);
				Log.netLogging(getName()+": connection at socket for crash");
				Log.netLogging("%% "+DetSock.toString());
				ObjectOutputStream DetWR=new ObjectOutputStream(DetSock.getOutputStream());
				DetWR.flush();
				//creazione ed invio di un ORIGIN_DETECT al demone di crash-detect del successivo
				DetWR.writeByte(Message.codeMsg("OD"));
				DetWR.writeObject(smsg);
				DetWR.flush();
				DetWR.close();
				DetSock.close();
				Log.netLogging(getName()+" successor OK");
				Log.srvLogging(getName()+" successor OK");
				synchronized(detect)	{detect.TurnOff();}
				Log.netLogging("(! ! !) "+getName()+" server DETECT-OFF");
				}//end try
			catch (ConnectException e)
				{//connessione non riuscita (nessuno in ascolto)
				//lancio processo gestore di crash
				ThreadCrash tc=new ThreadCrash(HostConfig);
				tc.start();
				try {tc.join();}
				catch (InterruptedException e1)	{/*ignored*/}
				synchronized(detect)	{detect.TurnOff();}
				Log.netLogging("(! ! !) "+getName()+" server DETECT-OFF");
				}
			catch (IOException e) {Log.netLogging("($$$) "+getName()+":  "+e);}
			}
		}
	}