//23/06/2000
//IMPLEMENTA IL PROCESSO DI INIZIALIZZAZIONE DEL SERVER
import java.net.*;
import java.io.*;

public class ThreadInit extends Thread
	{
	private InetAddress Sins;
	private ServerConfig HostConfig;
	private boolean insert_ok;
	ServerSocket NewSock;
	Socket PrecSock, SuccSock;
	
	
	ThreadInit(InetAddress i, ServerConfig s)
		{
		super("Thread-INIT");
		Sins=i;
		HostConfig=s;
		insert_ok=true;
		}
		
	public boolean isInsert()	{return insert_ok;}
	public void run()
		{
		try {
			Log.netLogging(getName()+" start");
			//creazione socket d'ascolto per nuovo successore
			NewSock=new ServerSocket(CServer.PORTNEW);
			Log.netLogging(getName()+": socket listen at "+CServer.PORTNEW);
			//richiesta di inserimento al server coordinatore
			//e inposizione del timeout di risposta
			PrecSock=new Socket(Sins, CServer.PORTINS);
			PrecSock.setSoTimeout(CServer.TIMEOUT_FOR_INSERT);
			Log.netLogging(getName()+": connection new predecessor");
			Log.netLogging("%% "+PrecSock.toString());
			//accettazione connessione nuovo successore
			//con timeout sulla accept
			NewSock.setSoTimeout(CServer.TIMEOUT_FOR_INSERT);
			SuccSock=NewSock.accept();
			Log.netLogging(getName()+": accept new successor");
			Log.netLogging("%% "+SuccSock.toString());
			//da qui in poi c' stato ANCHOR_SERVER
		/**/	ObjectOutputStream SuccWR=new ObjectOutputStream(SuccSock.getOutputStream());
		/**/	SuccWR.flush();
		/**/	ObjectInputStream PrecRD=new ObjectInputStream(PrecSock.getInputStream());
		/**/	ObjectOutputStream PrecWR=new ObjectOutputStream(PrecSock.getOutputStream());
		/**/	PrecWR.flush();
		/**/	ObjectInputStream SuccRD=new ObjectInputStream(SuccSock.getInputStream());
			byte typemsg=PrecRD.readByte();
			if (Message.decodeMsg(typemsg).equals("YPI"))
				{
				//ricezione YOUR_PRIORITY_IS
				MsgYourPriorityIs rmsg=(MsgYourPriorityIs) PrecRD.readObject();
				Log.netLogging(getName()+": receive a YOUR_PRIORITY_IS");
				Log.netLogging("%% "+PrecSock.toString());
				HostConfig.setPriorityHost(rmsg.getPriority());
				Log.netLogging(getName()+": set priority at "+rmsg.getPriority());
				rmsg.incPriority();
				//forword messaggio YOUR_PRIORITY-IS
				synchronized(SuccWR)
					{
					SuccWR.writeByte(Message.codeMsg("YPI"));
					SuccWR.writeObject(rmsg);
					SuccWR.flush();
					}
				Log.netLogging(getName()+": forword YOUR_PRIORITY_IS");
				Log.netLogging("%% "+SuccSock.toString());
				//ricezione database
				typemsg=PrecRD.readByte();
				if (Message.decodeMsg(typemsg).equals("db"))
					{
					//database
					Db database=(Db) PrecRD.readObject();
					Log.netLogging(getName()+": receive database");
					Log.netLogging("%% "+PrecSock.toString());
					HostConfig.setDatabase(database);
					typemsg=PrecRD.readByte();
					if (Message.decodeMsg(typemsg).equals("RSU"))
							{
							MsgResurrection rmsg2=(MsgResurrection) PrecRD.readObject();
							Log.netLogging(getName()+": receive a RESURRECTION");
							Log.netLogging("%% "+PrecSock.toString());
							//forword RESURRECTION
							synchronized(SuccWR)
								{
								SuccWR.writeByte(Message.codeMsg("RSU"));
								SuccWR.writeObject(rmsg2);
								SuccWR.flush();
								}
							Log.netLogging(getName()+": forword RESURRECTION");
							Log.netLogging("%% "+SuccSock.toString());
							}
					else
						Log.netLogging("[ERROR] "+getName()+": receive message, not RESURRECTION");
					}
				else
					Log.netLogging("($$$) [ERROR] "+getName()+": receive message, not DataBase copy");
				}
			else
				Log.netLogging("($$$) [ERROR] "+getName()+": receive message, not YOUR_PRIORITY_IS");
			//resettaggio del timeout
			PrecSock.setSoTimeout(0);
		/**/	HostConfig.setSuccSock(SuccSock);
		/**/	HostConfig.setPrecSock(PrecSock);
		/**/	HostConfig.setSuccWR(SuccWR);
		/**/	HostConfig.setPrecRD(PrecRD);
		/**/	HostConfig.setSuccRD(SuccRD);
		/**/	HostConfig.setPrecWR(PrecWR);
		//	SuccWR.close();
		//	SuccRD.close();
		//	PrecRD.close();
		//	PrecWR.close();
			NewSock.close();
			//definizione dei riferimenti (azioni effettuate quando i demoni sono fuori elaborazione)
			HostConfig.getDeamonBook().redefineSuccHost();
			HostConfig.getDeamonBook().redefinePrecHost();
			HostConfig.getDeamonNetwork().redefineSuccHost();
			HostConfig.getDeamonNetwork().redefinePrecHost();
			HostConfig.getDeamonCrash().redefineSuccHost();
			HostConfig.getDeamonCrash().redefinePrecHost();
			Log.netLogging(getName()+": redefine all connection");
			Log.netLogging("%% successor at "+SuccSock.toString());	
			Log.netLogging("%% predecessor at "+PrecSock.toString());
			//partenza dei demoni
			Log.netLogging(getName()+": all daemon started....");
			HostConfig.getDeamonCrash().start();
			HostConfig.getDeamonBook().start();
			HostConfig.getDeamonNetwork().start();
			HostConfig.getDeamonCrashDetect().start();
			HostConfig.getDeamonInsert().start();
			HostConfig.getDeamonRequest().start();
			Log.netLogging(getName()+" stop");
			Log.netLogging("------SERVER ACTIVE------");
			}
		catch (InterruptedIOException e) 	
			{
			insert_ok=false;
			Log.netLogging("######################################################");
			Log.netLogging("#### "+getName()+" INSERT FAIL!!!!!!!! Retry later ####");
			Log.netLogging("######################################################");
			try {
			NewSock.close();
			SuccSock.close();
			PrecSock.close();}
			catch (Exception e1) {/*ignored*/}
			stop();
			}
		catch (Exception e) 		{Log.netLogging("($$$) [EXCEPTION]"+getName()+" "+e);}
		}
	}